
QA_prompt = lambda query,context : f'''[INST] <<SYS>>
Using the given CONTEXT, answer the following True or False QUESTION. If the answer is YES output 1. If the answer is NO output 0.
<</SYS>>

CONTEXT : "{context}"

QUESTION : "{query}"[/INST]

OUTPUT NUMBER : '''


med_prompt = lambda query, context : f'''[INST] <<SYS>>
Using the given CONTEXT, answer the following QUESTION. The unit is in mg. Only output a number.

Exemples of answer : 30  / 900  / 10 
<</SYS>>

CONTEXT : "{context}"

QUESTION : "{query.lower()} ?"[/INST]

OUTPUT : '''

med_nocontext_prompt = lambda query, context : f'''[INST] <<SYS>>
Answer the following QUESTION. The unit is in mg. Only output a number.
<</SYS>>

QUESTION : "{query.lower()} ?"[/INST]

OUTPUT : '''

QA_nocontext_prompt = lambda query : f'''<<SYS>> 
Answer to the QUESTION. If the answer is YES output 1. If the answer is NO output 0.
<</SYS>

QUESTION: "{query}"[/INST]

OUTPUT NUMBER : '''


QA_score_nocontext_prompt = lambda query :f'''[INST] <<SYS>>
You are an agent that assess its own confidence to answer a query. If you know enough information to confidently answer correctly the QUESTION, you output 3. If you need more information or reasoning to answery correctly the QUESTION, you output 4.<</SYS>>

QUESTION : "{query}"

[/INST]

OUTPUT NUMBER : '''


QA_score_prompt = lambda query,thought: f'''[INST] <<SYS>>
You are an agent that rates the information contained in CONTEXT. If the information contains in the CONTEXT is accurate and you have all the information required to answer the QUESTION, you output 3. If the CONTEXT is not accurate or you don't have all the information required to answer the QUESTION, you output 4.
<</SYS>>

QUESTION : "{query}"

CONTEXT : "{thought}"[/INST]

OUTPUT NUMBER : '''

thought_generation_prompt = lambda query,thoughts, documents: f'''[INST] <<SYS>>
You are a thought generation agent. Given previous THOUGHTS and factual DOCUMENTS, generate a new thought that gathers the relevant elements required to answer the following QUESTION.
<</SYS>>

THOUGHTS : "{thoughts}"

DOCUMENTS : "{documents}"

QUESTION : "{query}"[/INST]

RESPONSE : '''


ade_thought_generation_prompt = lambda query,thoughts, documents: f'''[INST] <<SYS>>
As a thought generation agent, your task is to analyze previous THOUGHTS and a PATIENT RECORD. From this information, generate a new thought that compiles relevant elements needed to answer the following QUESTION. Focus on identifying a quantity, expressed in milligrams (mg), as it appears in the PATIENT RECORD or the THOUGHTS, before considering the dosage.
<</SYS>>

THOUGHTS : "{thoughts}"

PATIENT RECORD : "{documents}"

QUESTION : "{query.lower()}"[/INST]

RESPONSE : '''


document_query_prompt = lambda query,thoughts: f'''[INST] <<SYS>>
You are an agent that formulates a document query. Given previous THOUGHTS, formulate a query in English to retrieve the relevant information required to answer the QUESTION.
<</SYS>>

THOUGHTS : "{thoughts}"

QUESTION : "{query}"[/INST]

QUERY : '''


    
def generation_prompt(query, thoughts, documents, model):
    
    prompt_for_generation = model.thought_generation_prompt
    
    if len(thoughts) == 1:
        prompt_thought  = "{thought}".format(thought=thoughts[0])
    else:
        prompt_thought = ""
        for t in thoughts:
            prompt_thought += "{thought}\n".format(thought=t)
        prompt_thought = prompt_thought[:-2]
    if len(documents) == 1:
        prompt_document ="{document}".format(document=documents[0])
    else:
        prompt_document = ""
        for d in documents:
            prompt_document += "{document}\n".format(document=d)
        prompt_document = prompt_document[:-2]
        
    if type(query) == tuple:
        prompt = prompt_for_generation(query=query[0], choices=query[1], thoughts=prompt_thought, documents=prompt_document)
    else:
        prompt = prompt_for_generation(query=query, thoughts=prompt_thought, documents=prompt_document)
    return prompt
    